diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/bulk-send-application.cc ns-3.42/src/applications/model/bulk-send-application.cc
--- ns-3.41/src/applications/model/bulk-send-application.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/model/bulk-send-application.cc	2024-05-29 15:29:46.920073000 -0700
@@ -63,6 +63,12 @@
                           AddressValue(),
                           MakeAddressAccessor(&BulkSendApplication::m_local),
                           MakeAddressChecker())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&BulkSendApplication::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("MaxBytes",
                           "The total number of bytes to send. "
                           "Once these bytes are sent, "
@@ -153,6 +159,8 @@
                            "In other words, use TCP instead of UDP.");
         }
 
+        NS_ABORT_MSG_IF(m_peer.IsInvalid(), "'Remote' attribute not properly set");
+
         if (!m_local.IsInvalid())
         {
             NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
@@ -179,6 +187,10 @@
             NS_FATAL_ERROR("Failed to bind socket");
         }
 
+        if (InetSocketAddress::IsMatchingType(m_peer))
+        {
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+        }
         m_socket->Connect(m_peer);
         m_socket->ShutdownRecv();
         m_socket->SetConnectCallback(MakeCallback(&BulkSendApplication::ConnectionSucceeded, this),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/bulk-send-application.h ns-3.42/src/applications/model/bulk-send-application.h
--- ns-3.41/src/applications/model/bulk-send-application.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/model/bulk-send-application.h	2024-05-29 15:29:46.920073000 -0700
@@ -111,9 +111,8 @@
     void DoDispose() override;
 
   private:
-    // inherited from Application base class.
-    void StartApplication() override; // Called at time specified by Start
-    void StopApplication() override;  // Called at time specified by Stop
+    void StartApplication() override;
+    void StopApplication() override;
 
     /**
      * \brief Send data until the L4 transmission buffer is full.
@@ -126,6 +125,7 @@
     Address m_peer;                      //!< Peer address
     Address m_local;                     //!< Local address to bind to
     bool m_connected;                    //!< True if connected
+    uint8_t m_tos;                       //!< The packets Type of Service
     uint32_t m_sendSize;                 //!< Size of data to send each time
     uint64_t m_maxBytes;                 //!< Limit total number of bytes sent
     uint64_t m_totBytes;                 //!< Total bytes sent so far
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/onoff-application.cc ns-3.42/src/applications/model/onoff-application.cc
--- ns-3.41/src/applications/model/onoff-application.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/model/onoff-application.cc	2024-05-29 15:29:46.920073000 -0700
@@ -79,6 +79,12 @@
                           AddressValue(),
                           MakeAddressAccessor(&OnOffApplication::m_local),
                           MakeAddressChecker())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&OnOffApplication::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("OnTime",
                           "A RandomVariableStream used to pick the duration of the 'On' state.",
                           StringValue("ns3::ConstantRandomVariable[Constant=1.0]"),
@@ -186,6 +192,8 @@
         m_socket = Socket::CreateSocket(GetNode(), m_tid);
         int ret = -1;
 
+        NS_ABORT_MSG_IF(m_peer.IsInvalid(), "'Remote' attribute not properly set");
+
         if (!m_local.IsInvalid())
         {
             NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
@@ -216,6 +224,10 @@
         m_socket->SetConnectCallback(MakeCallback(&OnOffApplication::ConnectionSucceeded, this),
                                      MakeCallback(&OnOffApplication::ConnectionFailed, this));
 
+        if (InetSocketAddress::IsMatchingType(m_peer))
+        {
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+        }
         m_socket->Connect(m_peer);
         m_socket->SetAllowBroadcast(true);
         m_socket->ShutdownRecv();
@@ -256,7 +268,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_sendEvent.IsRunning() && m_cbrRateFailSafe == m_cbrRate)
+    if (m_sendEvent.IsPending() && m_cbrRateFailSafe == m_cbrRate)
     { // Cancel the pending send packet event
         // Calculate residual bits since last packet sent
         Time delta(Simulator::Now() - m_lastStartTime);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/onoff-application.h ns-3.42/src/applications/model/onoff-application.h
--- ns-3.41/src/applications/model/onoff-application.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/model/onoff-application.h	2024-05-29 15:29:46.920073000 -0700
@@ -122,22 +122,14 @@
      */
     Ptr<Socket> GetSocket() const;
 
-    /**
-     * \brief Assign a fixed random variable stream number to the random variables
-     * used by this model.
-     *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
-     */
-    int64_t AssignStreams(int64_t stream);
+    int64_t AssignStreams(int64_t stream) override;
 
   protected:
     void DoDispose() override;
 
   private:
-    // inherited from Application base class.
-    void StartApplication() override; // Called at time specified by Start
-    void StopApplication() override;  // Called at time specified by Stop
+    void StartApplication() override;
+    void StopApplication() override;
 
     // helpers
     /**
@@ -163,6 +155,7 @@
     Address m_peer;                      //!< Peer address
     Address m_local;                     //!< Local address to bind to
     bool m_connected;                    //!< True if connected
+    uint8_t m_tos;                       //!< The packets Type of Service
     Ptr<RandomVariableStream> m_onTime;  //!< rng for On Time
     Ptr<RandomVariableStream> m_offTime; //!< rng for Off Time
     DataRate m_cbrRate;                  //!< Rate that data is generated
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/packet-sink.cc ns-3.42/src/applications/model/packet-sink.cc
--- ns-3.41/src/applications/model/packet-sink.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/model/packet-sink.cc	2024-05-29 15:29:46.920073000 -0700
@@ -133,6 +133,7 @@
     if (!m_socket)
     {
         m_socket = Socket::CreateSocket(GetNode(), m_tid);
+        NS_ABORT_MSG_IF(m_local.IsInvalid(), "'Local' attribute not properly set");
         if (m_socket->Bind(m_local) == -1)
         {
             NS_FATAL_ERROR("Failed to bind socket");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/packet-sink.h ns-3.42/src/applications/model/packet-sink.h
--- ns-3.41/src/applications/model/packet-sink.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/model/packet-sink.h	2024-05-29 15:29:46.920073000 -0700
@@ -115,9 +115,8 @@
     void DoDispose() override;
 
   private:
-    // inherited from Application base class.
-    void StartApplication() override; // Called at time specified by Start
-    void StopApplication() override;  // Called at time specified by Stop
+    void StartApplication() override;
+    void StopApplication() override;
 
     /**
      * \brief Handle a packet received by the application
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/three-gpp-http-client.cc ns-3.42/src/applications/model/three-gpp-http-client.cc
--- ns-3.41/src/applications/model/three-gpp-http-client.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/three-gpp-http-client.cc	2024-05-29 15:29:46.920073000 -0700
@@ -80,6 +80,12 @@
                           UintegerValue(80), // the default HTTP port
                           MakeUintegerAccessor(&ThreeGppHttpClient::m_remoteServerPort),
                           MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&ThreeGppHttpClient::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddTraceSource("RxPage",
                             "A page has been received.",
                             MakeTraceSourceAccessor(&ThreeGppHttpClient::m_rxPageTrace),
@@ -362,7 +368,8 @@
         m_state == PARSING_MAIN_OBJECT || m_state == READING)
     {
         m_socket = Socket::CreateSocket(GetNode(), TcpSocketFactory::GetTypeId());
-
+        NS_ABORT_MSG_IF(m_remoteServerAddress.IsInvalid(),
+                        "'RemoteServerAddress' attribute not properly set");
         if (Ipv4Address::IsMatchingType(m_remoteServerAddress))
         {
             int ret [[maybe_unused]];
@@ -375,6 +382,7 @@
             InetSocketAddress inetSocket = InetSocketAddress(ipv4, m_remoteServerPort);
             NS_LOG_INFO(this << " Connecting to " << ipv4 << " port " << m_remoteServerPort << " / "
                              << inetSocket << ".");
+            m_socket->SetIpTos(m_tos);
             ret = m_socket->Connect(inetSocket);
             NS_LOG_DEBUG(this << " Connect() return value= " << ret
                               << " GetErrNo= " << m_socket->GetErrno() << ".");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/three-gpp-http-client.h ns-3.42/src/applications/model/three-gpp-http-client.h
--- ns-3.41/src/applications/model/three-gpp-http-client.h	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/three-gpp-http-client.h	2024-05-29 15:29:46.920073000 -0700
@@ -188,14 +188,12 @@
                                          uint32_t numBytes);
 
   protected:
-    // Inherited from Object base class.
     void DoDispose() override;
 
-    // Inherited from Application base class.
+  private:
     void StartApplication() override;
     void StopApplication() override;
 
-  private:
     // SOCKET CALLBACK METHODS
 
     /**
@@ -393,6 +391,8 @@
     Address m_remoteServerAddress;
     /// The `RemoteServerPort` attribute.
     uint16_t m_remoteServerPort;
+    /// The `Tos` attribute.
+    uint8_t m_tos;
 
     // TRACE SOURCES
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/three-gpp-http-server.cc ns-3.42/src/applications/model/three-gpp-http-server.cc
--- ns-3.41/src/applications/model/three-gpp-http-server.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/three-gpp-http-server.cc	2024-05-29 15:29:46.920073000 -0700
@@ -81,6 +81,12 @@
                           UintegerValue(80), // the default HTTP port
                           MakeUintegerAccessor(&ThreeGppHttpServer::m_localPort),
                           MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&ThreeGppHttpServer::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("Mtu",
                           "Maximum transmission unit (in bytes) of the TCP sockets "
                           "used in this application, excluding the compulsory 40 "
@@ -205,6 +211,9 @@
             m_initialSocket = Socket::CreateSocket(GetNode(), TcpSocketFactory::GetTypeId());
             m_initialSocket->SetAttribute("SegmentSize", UintegerValue(m_mtuSize));
 
+            NS_ABORT_MSG_IF(m_localAddress.IsInvalid(),
+                            "'LocalAddress' attribute not properly set");
+
             if (Ipv4Address::IsMatchingType(m_localAddress))
             {
                 const Ipv4Address ipv4 = Ipv4Address::ConvertFrom(m_localAddress);
@@ -214,6 +223,8 @@
                 int ret [[maybe_unused]] = m_initialSocket->Bind(inetSocket);
                 NS_LOG_DEBUG(this << " Bind() return value= " << ret
                                   << " GetErrNo= " << m_initialSocket->GetErrno() << ".");
+
+                m_initialSocket->SetIpTos(m_tos); // Affects only IPv4 sockets.
             }
             else if (Ipv6Address::IsMatchingType(m_localAddress))
             {
@@ -225,6 +236,10 @@
                 NS_LOG_DEBUG(this << " Bind() return value= " << ret
                                   << " GetErrNo= " << m_initialSocket->GetErrno() << ".");
             }
+            else
+            {
+                NS_ABORT_MSG("Incompatible local address");
+            }
 
             int ret [[maybe_unused]] = m_initialSocket->Listen();
             NS_LOG_DEBUG(this << " Listen () return value= " << ret
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/three-gpp-http-server.h ns-3.42/src/applications/model/three-gpp-http-server.h
--- ns-3.41/src/applications/model/three-gpp-http-server.h	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/three-gpp-http-server.h	2024-05-29 15:29:46.920073000 -0700
@@ -148,14 +148,12 @@
                                                   Ptr<Socket> socket);
 
   protected:
-    // Inherited from Object base class
     void DoDispose() override;
 
-    // Inherited from Application base class
+  private:
     void StartApplication() override;
     void StopApplication() override;
 
-  private:
     // SOCKET CALLBACK METHODS
 
     /**
@@ -272,6 +270,8 @@
     Address m_localAddress;
     /// The `LocalPort` attribute.
     uint16_t m_localPort;
+    /// The `Tos` attribute.
+    uint8_t m_tos;
     /// The `Mtu` attribute.
     uint32_t m_mtuSize;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-client.cc ns-3.42/src/applications/model/udp-client.cc
--- ns-3.41/src/applications/model/udp-client.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-client.cc	2024-05-29 15:29:46.920073000 -0700
@@ -71,6 +71,12 @@
                           UintegerValue(100),
                           MakeUintegerAccessor(&UdpClient::m_peerPort),
                           MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&UdpClient::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("PacketSize",
                           "Size of packets generated. The minimum packet size is 12 bytes which is "
                           "the size of the header carrying the sequence number and the time stamp.",
@@ -118,13 +124,6 @@
 }
 
 void
-UdpClient::DoDispose()
-{
-    NS_LOG_FUNCTION(this);
-    Application::DoDispose();
-}
-
-void
 UdpClient::StartApplication()
 {
     NS_LOG_FUNCTION(this);
@@ -139,6 +138,7 @@
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
             m_socket->Connect(
                 InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
@@ -157,6 +157,7 @@
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
             m_socket->Connect(m_peerAddress);
         }
         else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-client.h ns-3.42/src/applications/model/udp-client.h
--- ns-3.41/src/applications/model/udp-client.h	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-client.h	2024-05-29 15:29:46.920073000 -0700
@@ -71,9 +71,6 @@
      */
     uint64_t GetTotalTx() const;
 
-  protected:
-    void DoDispose() override;
-
   private:
     void StartApplication() override;
     void StopApplication() override;
@@ -98,6 +95,7 @@
     Ptr<Socket> m_socket;  //!< Socket
     Address m_peerAddress; //!< Remote peer address
     uint16_t m_peerPort;   //!< Remote peer port
+    uint8_t m_tos;         //!< The packets Type of Service
     EventId m_sendEvent;   //!< Event to send the next packet
 
 #ifdef NS3_LOG_ENABLE
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-echo-client.cc ns-3.42/src/applications/model/udp-echo-client.cc
--- ns-3.41/src/applications/model/udp-echo-client.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-echo-client.cc	2024-05-29 15:29:46.920073000 -0700
@@ -65,6 +65,12 @@
                           UintegerValue(0),
                           MakeUintegerAccessor(&UdpEchoClient::m_peerPort),
                           MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&UdpEchoClient::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddAttribute(
                 "PacketSize",
                 "Size of echo data in outbound packets",
@@ -126,13 +132,6 @@
 }
 
 void
-UdpEchoClient::DoDispose()
-{
-    NS_LOG_FUNCTION(this);
-    Application::DoDispose();
-}
-
-void
 UdpEchoClient::StartApplication()
 {
     NS_LOG_FUNCTION(this);
@@ -141,12 +140,14 @@
     {
         TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
+        NS_ABORT_MSG_IF(m_peerAddress.IsInvalid(), "'RemoteAddress' attribute not properly set");
         if (Ipv4Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
             m_socket->Connect(
                 InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
@@ -165,6 +166,7 @@
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
             m_socket->Connect(m_peerAddress);
         }
         else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-echo-client.h ns-3.42/src/applications/model/udp-echo-client.h
--- ns-3.41/src/applications/model/udp-echo-client.h	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-echo-client.h	2024-05-29 15:29:46.920073000 -0700
@@ -130,9 +130,6 @@
      */
     void SetFill(uint8_t* fill, uint32_t fillSize, uint32_t dataSize);
 
-  protected:
-    void DoDispose() override;
-
   private:
     void StartApplication() override;
     void StopApplication() override;
@@ -167,6 +164,7 @@
     Ptr<Socket> m_socket;  //!< Socket
     Address m_peerAddress; //!< Remote peer address
     uint16_t m_peerPort;   //!< Remote peer port
+    uint8_t m_tos;         //!< The packets Type of Service
     EventId m_sendEvent;   //!< Event to send the next packet
 
     /// Callbacks for tracing the packet Tx events
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-echo-server.cc ns-3.42/src/applications/model/udp-echo-server.cc
--- ns-3.41/src/applications/model/udp-echo-server.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-echo-server.cc	2024-05-29 15:29:46.920073000 -0700
@@ -51,6 +51,12 @@
                           UintegerValue(9),
                           MakeUintegerAccessor(&UdpEchoServer::m_port),
                           MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&UdpEchoServer::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddTraceSource("Rx",
                             "A packet has been received",
                             MakeTraceSourceAccessor(&UdpEchoServer::m_rxTrace),
@@ -75,13 +81,6 @@
 }
 
 void
-UdpEchoServer::DoDispose()
-{
-    NS_LOG_FUNCTION(this);
-    Application::DoDispose();
-}
-
-void
 UdpEchoServer::StartApplication()
 {
     NS_LOG_FUNCTION(this);
@@ -134,6 +133,7 @@
         }
     }
 
+    m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
     m_socket->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
     m_socket6->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-echo-server.h ns-3.42/src/applications/model/udp-echo-server.h
--- ns-3.41/src/applications/model/udp-echo-server.h	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-echo-server.h	2024-05-29 15:29:46.920073000 -0700
@@ -52,9 +52,6 @@
     UdpEchoServer();
     ~UdpEchoServer() override;
 
-  protected:
-    void DoDispose() override;
-
   private:
     void StartApplication() override;
     void StopApplication() override;
@@ -69,6 +66,7 @@
     void HandleRead(Ptr<Socket> socket);
 
     uint16_t m_port;       //!< Port on which we listen for incoming packets.
+    uint8_t m_tos;         //!< The packets Type of Service
     Ptr<Socket> m_socket;  //!< IPv4 Socket
     Ptr<Socket> m_socket6; //!< IPv6 Socket
     Address m_local;       //!< local multicast address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-server.cc ns-3.42/src/applications/model/udp-server.cc
--- ns-3.41/src/applications/model/udp-server.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-server.cc	2024-05-29 15:29:46.920073000 -0700
@@ -54,6 +54,12 @@
                           UintegerValue(100),
                           MakeUintegerAccessor(&UdpServer::m_port),
                           MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&UdpServer::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("PacketWindowSize",
                           "The size of the window used to compute the packet loss. This value "
                           "should be a multiple of 8.",
@@ -73,10 +79,10 @@
 }
 
 UdpServer::UdpServer()
-    : m_lossCounter(0)
+    : m_received(0),
+      m_lossCounter(0)
 {
     NS_LOG_FUNCTION(this);
-    m_received = 0;
 }
 
 UdpServer::~UdpServer()
@@ -113,13 +119,6 @@
 }
 
 void
-UdpServer::DoDispose()
-{
-    NS_LOG_FUNCTION(this);
-    Application::DoDispose();
-}
-
-void
 UdpServer::StartApplication()
 {
     NS_LOG_FUNCTION(this);
@@ -135,6 +134,7 @@
         }
     }
 
+    m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
     m_socket->SetRecvCallback(MakeCallback(&UdpServer::HandleRead, this));
 
     if (!m_socket6)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-server.h ns-3.42/src/applications/model/udp-server.h
--- ns-3.41/src/applications/model/udp-server.h	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-server.h	2024-05-29 15:29:46.920073000 -0700
@@ -82,9 +82,6 @@
      */
     void SetPacketWindowSize(uint16_t size);
 
-  protected:
-    void DoDispose() override;
-
   private:
     void StartApplication() override;
     void StopApplication() override;
@@ -99,6 +96,7 @@
     void HandleRead(Ptr<Socket> socket);
 
     uint16_t m_port;                 //!< Port on which we listen for incoming packets.
+    uint8_t m_tos;                   //!< The packets Type of Service
     Ptr<Socket> m_socket;            //!< IPv4 Socket
     Ptr<Socket> m_socket6;           //!< IPv6 Socket
     uint64_t m_received;             //!< Number of received packets
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-trace-client.cc ns-3.42/src/applications/model/udp-trace-client.cc
--- ns-3.41/src/applications/model/udp-trace-client.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-trace-client.cc	2024-05-29 15:29:46.920073000 -0700
@@ -79,6 +79,12 @@
                           UintegerValue(100),
                           MakeUintegerAccessor(&UdpTraceClient::m_peerPort),
                           MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&UdpTraceClient::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("MaxPacketSize",
                           "The maximum size of a packet (including the SeqTsHeader, 12 bytes).",
                           UintegerValue(1024),
@@ -176,13 +182,6 @@
 }
 
 void
-UdpTraceClient::DoDispose()
-{
-    NS_LOG_FUNCTION(this);
-    Application::DoDispose();
-}
-
-void
 UdpTraceClient::LoadTrace(std::string filename)
 {
     NS_LOG_FUNCTION(this << filename);
@@ -258,12 +257,14 @@
     {
         TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
+        NS_ABORT_MSG_IF(m_peerAddress.IsInvalid(), "'RemoteAddress' attribute not properly set");
         if (Ipv4Address::IsMatchingType(m_peerAddress))
         {
             if (m_socket->Bind() == -1)
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
             m_socket->Connect(
                 InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
@@ -282,6 +283,7 @@
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
+            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
             m_socket->Connect(m_peerAddress);
         }
         else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/model/udp-trace-client.h ns-3.42/src/applications/model/udp-trace-client.h
--- ns-3.41/src/applications/model/udp-trace-client.h	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/model/udp-trace-client.h	2024-05-29 15:29:46.920073000 -0700
@@ -124,10 +124,10 @@
      */
     void SetTraceLoop(bool traceLoop);
 
-  protected:
-    void DoDispose() override;
-
   private:
+    void StartApplication() override;
+    void StopApplication() override;
+
     /**
      * \brief Load a trace file
      * \param filename the trace file path
@@ -137,8 +137,6 @@
      * \brief Load the default trace
      */
     void LoadDefaultTrace();
-    void StartApplication() override;
-    void StopApplication() override;
 
     /**
      * \brief Send a packet
@@ -166,6 +164,7 @@
     Ptr<Socket> m_socket;  //!< Socket
     Address m_peerAddress; //!< Remote peer address
     uint16_t m_peerPort;   //!< Remote peer port
+    uint8_t m_tos;         //!< The packets Type of Service
     EventId m_sendEvent;   //!< Event to send the next packet
 
     std::vector<TraceEntry> m_entries;    //!< Entries in the trace to send
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/test/bulk-send-application-test-suite.cc ns-3.42/src/applications/test/bulk-send-application-test-suite.cc
--- ns-3.41/src/applications/test/bulk-send-application-test-suite.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/test/bulk-send-application-test-suite.cc	2024-05-29 15:29:46.920073000 -0700
@@ -274,10 +274,10 @@
 };
 
 BulkSendTestSuite::BulkSendTestSuite()
-    : TestSuite("bulk-send-application", UNIT)
+    : TestSuite("applications-bulk-send", Type::UNIT)
 {
-    AddTestCase(new BulkSendBasicTestCase, TestCase::QUICK);
-    AddTestCase(new BulkSendSeqTsSizeTestCase, TestCase::QUICK);
+    AddTestCase(new BulkSendBasicTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new BulkSendSeqTsSizeTestCase, TestCase::Duration::QUICK);
 }
 
 static BulkSendTestSuite g_bulkSendTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/test/three-gpp-http-client-server-test.cc ns-3.42/src/applications/test/three-gpp-http-client-server-test.cc
--- ns-3.41/src/applications/test/three-gpp-http-client-server-test.cc	2024-02-09 14:44:07.857789800 -0800
+++ ns-3.42/src/applications/test/three-gpp-http-client-server-test.cc	2024-05-29 15:29:46.920073000 -0700
@@ -799,7 +799,7 @@
   public:
     /// Instantiate the test suite.
     ThreeGppHttpClientServerTestSuite()
-        : TestSuite("three-gpp-http-client-server-test", SYSTEM)
+        : TestSuite("applications-three-gpp-http-client-server", Type::SYSTEM)
     {
         // LogComponentEnable ("ThreeGppHttpClientServerTest", LOG_INFO);
         // LogComponentEnable ("ThreeGppHttpClient", LOG_INFO);
@@ -873,14 +873,14 @@
         }
 
         // Assign higher fullness for tests with higher RngRun.
-        TestCase::TestDuration testDuration = TestCase::QUICK;
+        TestCase::Duration testDuration = TestCase::Duration::QUICK;
         if (rngRun > 20)
         {
-            testDuration = TestCase::EXTENSIVE;
+            testDuration = TestCase::Duration::EXTENSIVE;
         }
         if (rngRun > 50)
         {
-            testDuration = TestCase::TAKES_FOREVER;
+            testDuration = TestCase::Duration::TAKES_FOREVER;
         }
 
         AddTestCase(new ThreeGppHttpObjectTestCase(name.str(),
